import _objectDestructuringEmpty from "@babel/runtime/helpers/esm/objectDestructuringEmpty";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["design", "variant", "as", "children", "className", "fontSize", "fontFamily", "fontWeight", "fontStyle", "fontStretch", "letterSpacing", "lineHeight", "textDecorationLine", "isLinked", "isBlurred"];
import PropTypes from 'prop-types';
import PolymorphicElement from '@s-ui/react-primitive-polymorphic-element';
import ComponentTypes from './component/index.js';
import { DESIGN, FONT_FAMILY, FONT_SIZE, FONT_STRETCH, FONT_STYLE, FONT_WEIGHT, LETTER_SPACING, LINE_HEIGHT, TEXT_DECORATION_LINE, VARIANT } from './config.js';
import useTypography from './useTypography.js';
import { jsx as _jsx } from "react/jsx-runtime";
var PrimitiveTypography = function PrimitiveTypography(_ref) {
  var design = _ref.design,
    variant = _ref.variant,
    _ref$as = _ref.as,
    as = _ref$as === void 0 ? 'span' : _ref$as,
    children = _ref.children,
    className = _ref.className,
    fontSize = _ref.fontSize,
    fontFamily = _ref.fontFamily,
    fontWeight = _ref.fontWeight,
    fontStyle = _ref.fontStyle,
    fontStretch = _ref.fontStretch,
    letterSpacing = _ref.letterSpacing,
    lineHeight = _ref.lineHeight,
    textDecorationLine = _ref.textDecorationLine,
    isLinked = _ref.isLinked,
    isBlurred = _ref.isBlurred,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _useTypography = useTypography(_extends({
      className: className,
      design: design,
      variant: variant,
      as: as,
      fontSize: fontSize,
      fontFamily: fontFamily,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      fontStretch: fontStretch,
      letterSpacing: letterSpacing,
      lineHeight: lineHeight,
      textDecorationLine: textDecorationLine,
      isLinked: isLinked,
      isBlurred: isBlurred,
      children: children
    }, props)),
    resultingProps = _extends({}, (_objectDestructuringEmpty(_useTypography), _useTypography));
  return /*#__PURE__*/_jsx(PolymorphicElement, _extends({}, resultingProps));
};
PrimitiveTypography.displayName = 'PrimitiveTypography';
var Display1 = ComponentTypes.Display1,
  Display2 = ComponentTypes.Display2,
  Display3 = ComponentTypes.Display3,
  Headline1 = ComponentTypes.Headline1,
  Headline2 = ComponentTypes.Headline2,
  SubHead = ComponentTypes.SubHead,
  Body1 = ComponentTypes.Body1,
  Body2 = ComponentTypes.Body2,
  Caption = ComponentTypes.Caption,
  Small = ComponentTypes.Small,
  Callout = ComponentTypes.Callout;
export default PrimitiveTypography;
export { useTypography, DESIGN as primitiveTypographyDesign, VARIANT as primitiveTypographyVariant, FONT_SIZE as primitiveTypographyFontSize, FONT_FAMILY as primitiveTypographyFontFamily, FONT_WEIGHT as primitiveTypographyFontWeight, FONT_STYLE as primitiveTypographyFontStyle, FONT_STRETCH as primitiveTypographyFontStretch, LETTER_SPACING as primitiveTypographyLetterSpacing, LINE_HEIGHT as primitiveTypographyLineHeight, TEXT_DECORATION_LINE as primitiveTypographyTextDecoration, Display1 as PrimitiveTypographyDisplay1, Display2 as PrimitiveTypographyDisplay2, Display3 as PrimitiveTypographyDisplay3, Headline1 as PrimitiveTypographyHeadline1, Headline2 as PrimitiveTypographyHeadline2, SubHead as PrimitiveTypographySubHead, Body1 as PrimitiveTypographyBody1, Body2 as PrimitiveTypographyBody2, Caption as PrimitiveTypographyCaption, Small as PrimitiveTypographySmall, Callout as PrimitiveTypographyCallout };